package com.vanheusden.pfa;

import java.util.*;

class ChessObjectBishop extends ChessObject {
	public boolean equals(Object o) {
		final ChessObject oco = (ChessObject)o;

		return oco instanceof ChessObjectBishop && oco.getX() == x && oco.getY() == y && oco.getColor() == color && oco.getNMoves() == nMoves;
	}

	public ChessObjectBishop(final int x, final int y, final PlayerColor color) {
		super(x, y, color, 0);
	}

	public ChessObjectBishop(final int x, final int y, final PlayerColor color, final int nMoves) {
		super(x, y, color, nMoves);
	}

	public ChessObject duplicate() {
		return new ChessObjectBishop(x, y, color, nMoves);
	}

	public ChessObjectType getType() {
		return ChessObjectType.BISHOP;
	}

	public String getTypeCharacter(final boolean uppercase) {
		final String character = ChessObjectType.BISHOP.getName();

		if (uppercase)
			return character.toUpperCase();

		return character;
	}

	public void getMoves(final Scene scene, final List<Move> moves, final ChessObject king, final Move lastMove) {
		assert board == null;
		assert this.moves == null;

		board = scene.getBoard();
		this.moves = moves;

		getMovesPath( 1,  1);
		getMovesPath(-1,  1);
		getMovesPath( 1, -1);
		getMovesPath(-1, -1);

		assert canDoNMoves <= 16;

		generatedListOfMoves = true;
	}
}
