package com.vanheusden.pfa;

import java.util.*;

public class ChessObjectKing extends ChessObject {
	public boolean equals(Object o) {
		final ChessObject oco = (ChessObject)o;

		return oco instanceof ChessObjectKing && oco.getX() == x && oco.getY() == y && oco.getColor() == color && oco.getNMoves() == nMoves;
	}

	/* public stuff */
	public ChessObjectKing(final int x, final int y, final PlayerColor color) {
		super(x, y, color, 0);
	}

	public ChessObjectKing(final int x, final int y, final PlayerColor color, final int nMoves) {
		super(x, y, color, nMoves);
	}

	public ChessObject duplicate() {
		return new ChessObjectKing(x, y, color, nMoves);
	}

	public ChessObjectType getType() {
		return ChessObjectType.KING;
	}

	public String getTypeCharacter(final boolean uppercase) {
		final String character = ChessObjectType.KING.getName();

		if (uppercase)
			return character.toUpperCase();

		return character;
	}

	public void getMoves(final Scene scene, final List<Move> moves, final ChessObject king, final Move lastMove) {
		assert board == null;
		assert this.moves == null;

		board = scene.getBoard();
		this.moves = moves;

		final int xp = x + 1, yp = y + 1;
		final int xm = x - 1, ym = y - 1;

		if (ym >= 0)
			conditionalAddMove(x, y, x, ym);

		if (yp <= 7)
			conditionalAddMove(x, y, x, yp);

		if (xm >= 0)
		{
			conditionalAddMove(x, y, xm, y);

			if (ym >= 0)
				conditionalAddMove(x, y, xm, ym);

			if (yp <= 7)
				conditionalAddMove(x, y, xm, yp);
		}

		if (xp <= 7)
		{
			conditionalAddMove(x, y, xp, y);

			if (ym >= 0)
				conditionalAddMove(x, y, xp, ym);

			if (yp <= 7)
				conditionalAddMove(x, y, xp, yp);
		}

		assert canDoNMoves <= 8;

		generatedListOfMoves = true;
	}
}
