package com.vanheusden.pfa;

import java.io.IOException;

import android.app.Service;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.widget.Toast;

public class PosService extends Service {
	Thread t = null;
	static String msgFilter = "com.vanheusden.pfa.msg";

	@Override
	public IBinder onBind(Intent arg0) {
		return null;
	}

	@Override
	public void onCreate() {
		super.onCreate();
		Toast.makeText(this, "Starting DeepBrutePos..., Toast.LENGTH_LONG).show();

		String preferencesName = "DBP";
		SharedPreferences settings = getSharedPreferences(preferencesName, 0);

		String preferencePort = "tcplistenport";
		int port = Integer.valueOf(settings.getString(preferencePort, "12366"));
		System.out.println("Port from preferences: " + port);

		String preferenceMaxDepth = "maxDepth";
		int maxDepth = Integer.valueOf(settings.getString(preferenceMaxDepth, "5"));

		String preferenceMaxExtension = "maxExtension";
		int maxExtension = Integer.valueOf(settings.getString(preferenceMaxExtension, "5"));

		String preferenceRandom = "random";
		//int maxDepth = Integer.valueOf(settings.getString(preferenceMaxDepth, "5"));
		boolean random = true;

		String preferenceMaxNProcs = "maxNProcs";
		int maxNProcs = Integer.valueOf(settings.getString(preferenceMaxNProcs, "0"));

		String preferenceMaxDuration = "maxDuration";
		double maxDuration = Double.valueOf(settings.getString(preferenceMaxDuration, "30"));

		String preferenceMaxTransTabSize = "maxTransTabSize";
		int maxTransTabSize = Integer.valueOf(settings.getString(preferenceMaxTransTabSize, "65536"));

		PosWrapper wp = new PosWrapper(this, port, maxDepth, maxExtension, random, maxNProcs, maxDuration, transTabSize);

		port = wp.getPort();
		SharedPreferences.Editor editor = settings.edit();
		editor.putString(preferencePort, "" + port);
		editor.commit();

		t = new Thread(wp);
		t.start();
	}

	public void sendMessage(String msg) {
		Intent i = new Intent();
		i.setAction(msgFilter);
		i.putExtra("msg", msg);

		sendBroadcast(i);

		System.out.println(msg);
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		Toast.makeText(this, "POS main-loop stopped", Toast.LENGTH_LONG).show();
	}
}
